import * as React from 'react';
import styled from 'styled-components';
import SearchIcon from 'react-feather/dist/icons/search';
import { get } from "../../../utils/theme";
var sidebarBorder = get('colors.sidebarBorder', '#CED4DE');
var sidebarText = get('colors.sidebarText', '#13161F');
var Wrapper = styled.div.withConfig({
  displayName: "Search__Wrapper"
})(["display:flex;align-items:center;padding:5px 24px;margin-bottom:20px;border-top:1px dotted ", ";border-bottom:1px dotted ", ";opacity:1;"], sidebarBorder, sidebarBorder);
var Icon = styled(SearchIcon).withConfig({
  displayName: "Search__Icon"
})(["stroke:", ";min-width:20px;opacity:0.5;"], sidebarText);
var Input = styled.input.withConfig({
  displayName: "Search__Input"
})(["outline:none;width:100%;padding:10px;background:transparent;border:none;font-size:16px;color:", ";"], sidebarText);
export var Search = function Search(_ref) {
  var onSearch = _ref.onSearch;
  var browserLanguage = window.navigator.language;
  var placeholder = 'Search here...';

  if (browserLanguage === 'zh-CN') {
    placeholder = '在组件库中搜索...';
  }

  return React.createElement(Wrapper, null, React.createElement(Icon, null), React.createElement(Input, {
    type: "text",
    placeholder: placeholder,
    onChange: function onChange(ev) {
      onSearch && onSearch(ev.target.value);
    }
  }));
};